/* TlibCopy --  (C) Copyright 2002, Burton Systems Software.  All rights reserved. */
/* Burton Systems Software: http://www.burtonsys.com/ */
/* written by David A. Burton, dave@burtonsys.com */

/*+=>keyflag<=-- "\0&(#)%n, version %v, %d \0" */
static char version[] = "\0&(#)tlibcopy.c, version 48, 15-Nov-02 \0";

/* This program is written in MS VC/C++ 6.0, and currently is just for Win32,
   despite the fragments of code, here and there, for other environments.
   Sorry.  Please email Dave Burton if you want permission to port it to
   another environment.
*/


/* Here is the tlibcopy.dsp file, pkzipped and xxencoded:

section 1 of xxencode 5.15 of file tlcp_dsp.zip    by R.E.M.

begin 644 tlcp_dsp.zip
hI2g1--E++U+6+CttGWpYkN3A+EE++-IC+++A+0E+R4ldMaBjQ5YiN5Bk0U+U
h+++++++-+-U++2WLN73kkU2+cDC+2L10+I1fKlJ2Pw6-rJRhHyAs2DuCl5yM
hnRo5KCopdJoV3ZpDOdCoedOye0b5vOdGtHXHp6RXFos0tRyTwoc9dP0QvgCh
h-46wbbbawRVyMbu-2OB8lb8JU6prm4K20hkYxNa2eN7z6oqUnnX0Pn+a6LOA
hV1CDmiX-o7sdcPQYE7XQ0pGRrnzzQLlo250+CcsYu2AjNRnDUHx-LueE7D+b
hedV7+SSBNXD1yTUFv+aA7rBkvC3Q1syDAjSwCljAjooRA4uMO9TUN5BlTUeK
h395I99hFl-YZWEMmc9ZdbXLPKNfJ5rEesddrYKaXZkP5Flx4Xihq-kvApmk4
hzGBY+UHi04QyVCEKJtdZ+yMGj7loYcJ3NKjGa6Y+leDiJyTH3ZEOcst1Q1OF
hJ+aAGVGUAUm7w05vJObMmhUmQnEkJp1rie3d46rxoRxY0dE6W0CYPDKUaJAd
hJWl6JRs3i3yXm4e7aiVKgjQ+jaOKnqJwEu9r1bGrE4RaXcckNo9rECwIs6O2
h2QT95y8SEHsSbRoRADMXHKIQAmzfqJcmWX4gRD5RdF5p2crbdKP6YQFck6ab
hzzXNyZsxE8Q52EjmvwIf1bAD+mOeStMtdfD739eQmzgd8WhTfMoF0Vw3NPc7
hnHf6dLGN7KOr2UlXlrwZ8S3HYenn0KguvJ1Sk+oS5wpQeuBcMKgqknu+wSi7
hrdpH+neR+rofyCMJSZrLUSgMZuCyhIKcRiSBKJslHl4pmnYDaOF7Z0N9amYk
h5h4r6sMWEFKWnoW0Vy9aF+JM6XpCDKRqaBF-DayUwcl3pvM9TfflM+f7NG1-
hj4a1CTU9n2Y9H-iAay4srH7mQqkvjSh-MGyhmRWRL1bZOBGnL4pyorZx4olO
hkTxrm1blaKi-mO4tyRnw+eNT+pJ-9wzrL8jRubUlnMGnC4NPiDZgFPmSqLJS
h1QRTBEFbsjNNTX25huU2wbOfkNaLGOoenQ-bdLLDF-l7mTA-ZO5DUr84y5QY
heg9WBT68Fr7wh2WOJD+dwkijvx2eE7go8UTpBgGd3nz20MOLh9nvNYXcaUaw
h59Mjnei3Z4gk3d4GETNFK6Hp-zCClGbV2CRTmwIRzL8lo0IKYji0V-VbxMnz
huyeDXnssJuvnii7I5sJruwrNmrdHMFxKarpFzoNfnjNenNAefx6M-Y6eL-ND
hWUlxeyeDO3-MeALr6NUHzuZW9Byg46DjHzJc-tqx1vqjLeWkLtSKfyXGwdqu
ht3vrtfCiBTyNlQbDXhTi9EInwfrY6Q9948DY7pKgDOpUUWcAIGG2LkftlhPI
hNuHgHlOUgoLlgb94xf0zwwcfvaXV8Fth-ltP9sMwWY8-ugdIIQnzYweUrQbp
hn56uXILxzAtjY0DwrQX0JJ2eFjInx-xEGk204E+I++6+0+1iSIchNA4FH+22
h+++J1U++1++++++++++++6++++++++++R4ldMaBjQ5YiN5BkI2g3-U+++++-
B++2+CU+++2w2++++++++
+
end
*/



#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <errno.h>
#include <malloc.h>
#include <io.h>
#include <direct.h>

#define WIN32_LEAN_AND_MEAN
#include <windows.h>  /* declare SetFileAttributes() */


#ifdef WIN32
  #define FLAT32 1
#endif
#if defined(__WATCOMC__) || defined(__EXPRESSC__)
  #if defined(__FLAT__)
    #define FLAT32 1
  #endif
#endif
#ifndef FLAT32
  #define FLAT32 0
#endif


#ifndef FA_HIDDEN
  /* Microsoft C & TopSpeed C */

  /* Note: these are the same values as the corresponding symbols in BSEDOS.H:
     FILE_READONLY, FILE_HIDDEN, FILE_SYSTEM, FILE_DIRECTORY, FILE_ARCHIVED. */

  #define FA_HIDDEN _A_HIDDEN
  #define FA_SYSTEM _A_SYSTEM
  #define FA_RDONLY _A_RDONLY
  #define FA_DIREC _A_SUBDIR
  #define FA_ARCH _A_ARCH
#endif

/* There is nothing in BSEDOS.H corresponding to FA_LABEL, a.k.a. _A_VOLID */
#ifndef FA_LABEL
  #ifndef _A_VOLID
    #define _A_VOLID 0x08  /* MSC 5.0's DOS.H is missing this definition */
  #endif
  #define FA_LABEL _A_VOLID  /* Microsoft C & Topspeed C */
#endif

typedef enum { false_c=0, true_c=1} boolean_t;
typedef char filepath_t[_MAX_PATH+2];

int bothways = 0;  /* 1 iff -b option is specified, 2 if -bb is specified */
enum {dash_qq_c=0, dash_q_c=1, dash_default_c=2, dash_v_c=3, dash_vv_c=4} verbosity = dash_default_c;
boolean_t testmode = false_c;  /* true iff -t option is specified */
boolean_t makedirs = false_c;  /* true iff -m option is specified */
boolean_t dosubdirs = false_c;  /* true iff -i ("include subdirs") option is specified */

char option_str[20];  /* will contain normalized list of key options, for display */


/* Similar to strncpy (string copy) except that we only copy as many bytes
   as necessary, and dest[] is certain to be 0-terminated because we stuff
   a 0-byte after the last character.  Note that this means that dest[]
   *MUST* be at least maxlen+1 bytes long!  If (maxlen<=0) or (src==NULL),
   then only the '\0' terminator is stored.  However, if dest is NULL, then
   this function is a NO-OP.
*/
void my_strncpy(char *dest, const char *src, int maxlen)
  {
   register int len;
    if (dest)
      {
        len = 0;
        if ((maxlen > 0) && src)
           len = strlen(src);
        if (!len)
            dest[0] = '\0';
        else if (len < maxlen)
            strcpy( dest, src );
        else
          {
            strncpy( dest, src, (size_t)maxlen );
            dest[maxlen] = '\0';
          }
      }/*if*/
  } /* my_strncpy */


/* Like strncat(), but ensures that dest is null-terminated when done, and
   the third parameter is a maximum final length instead of a maximum number
   of bytes to copy.
   Note that this means that dest[] *MUST* be at least maxlen+1 bytes long!
   If maxlen == 0, then only the '\0' terminator is stored.  If src is NULL
   or of zero length, then this function does nothing except store a 0-byte
   at dest[maxlen] to ensure that the result is no longer than maxlen bytes.
   However, if dest is NULL, then this function is a NO-OP.
*/
void my_strncat(char *dest, const char *src, int maxlen)
  {
   int len;
    if (dest)
      {
       len = strlen(dest);
       if (len >= maxlen)
          dest[maxlen] = '\0';
       else
          my_strncpy(dest+len, src, maxlen-len);
     }
  } /* my_strncat */


/* return true iff name[] contains "*" and/or "?" character(s) */
boolean_t is_wild_card_spec( const char * name )
  {
    return (NULL != strpbrk(name,"*?"));
  } /* is_wild_card_spec */


void my_fclose( FILE * fil )
  {
    if (fil)
        fclose( fil );
  } /* my_fclose */


void show_banner( void )
  {
   static boolean_t shown = false_c;
    if ((!shown) && (verbosity >= dash_default_c))
      {
        printf( "TLIBCOPY 1.02 -- Copyright 2002, Burton Systems Software.\n" );
        shown = true_c;
      }
  } /* show_banner */


void give_help( void )
  {
    show_banner();
    printf( "\n"
            "Use Tlibcopy to safely, easily, and quickly back-up or \"synchronize\"\n"
            "directories of TLIB libraries (and TLIB journal files).\n"
            "\n"
            "Tlibcopy is totally safe.  It cannot destroy any of your data, no matter what\n"
            "you do with it, because (like TLIB) it only appends, never replaces, existing\n"
            "files.\n"
            "\n"
            "Tlibcopy is ideal for copying files that are only modified by appending.  If\n"
            "both \"source\" and \"target\" file already exist, tlibcopy will append the\n"
            "tail of the source file to the target, but only after first verifying that the\n"
            "target file is both shorter than the source file, and identical to the first\n"
            "part of the source file.\n"
            "\n"
            "Usage:\n"
            "     tlibcopy [options] file1 file2\n"
            " or  tlibcopy [options] file1 directory\\\n"
            "\n"
            "where:\n"
            "     file1 is the path & name of a longer TLIB library file, and\n"
            "     file2 is the path & name of a shorter TLIB library file, or\n"
            "     directory\\ is a directory path\n"
            "     [options] are optional: -b, -bb, -t -m, -i, -h, -v, -vv, -q, -qq\n"
            "\n"
            "Options can be merged, too:  -bbmi or -imbb is equivalent to -bb -m -i\n"
            "\n"
            "If file1 and file2 are identical files, then nothing is copied, and\n"
            "errorlevel 0 is returned.\n"
            "\n"
            "If file1 is longer than file2, but file2 is identical to the first part of\n"
            "file1, then the tail of file1 (the source file) is appended to file2 (the\n"
            "target file), to make the two files identical, and errorlevel 0 is returned.\n"
            "\n"
            "If file2 is not identical to the first part of file1, then nothing is copied,\n"
            "an error message is displayed (by default), and errorlevel 1 is returned.\n"
            "\n"
            "If file1 and file2 are the same size but not identical, or if file1 is\n"
            "shorter than file2 and -b isn't specified, then nothing is copied, an\n"
            "error message is displayed (by default), and errorlevel 1 is returned.\n"
            "\n"
            "If a directory\\ is specified instead of file2, then you can use wildcards\n"
            "in file1 to specify multiple files.\n"
            "\n"
            "-b (\"both ways\") makes tlibcopy work in either direction, copying from\n"
            "longer files to shorter files.  So, unless file1 uses wild-cards, these two\n"
            "commands are equivalent:\n"
            "\n"
            "     tlibcopy -b file1 file2\n"
            "     tlibcopy -b file2 file1\n"
            "\n"
            "-bb (\"both ways & backwards\") makes tlibcopy completely symmetrical, even\n"
            "if you use wild-cards.  It is like -b, except that if file1 contains a\n"
            "wildcard specification then tlibcopy will also expand the wildcard spec in\n"
            "both directories (skipping duplicate names).  So these two commands are\n"
            "exactly equivalent, except for the order in which the files are examined:\n"
            "\n"
            "     tlibcopy -bbim c:\\tlib\\libs\\*.?$* \\\\notebook\\d\\tlib\\libs\\\n"
            "     tlibcopy -bbim \\\\notebook\\d\\tlib\\libs\\*.?$* c:\\tlib\\libs\\\n"
            "\n"
            "-i (\"include subdirectories\") to recursively process all sub-folders.\n"
            "(To see what subdirectories (folders) it would process, without actually\n"
            "doing anything, use \"-iqt\")\n"
            "\n"
            "-t (\"test\") don't actually copy anything, just show what would be done\n"
            "if -t were not specified.\n"
            "\n"
            "-m (\"make directories\") to create missing folders if needed; if -t is also\n"
            "specified then -m has no effect.\n"
            "\n"
            "-v (\"verbose\") enables more status messages.\n"
            "-vv (\"very verbose\") enables even more status messages.\n"
            "-q (\"quiet\") enables fewer status messages and suppreses the copyright banner.\n"
            "-qq (\"very quiet\") disables all messages except error messages.\n"
            "\n"
            "-h or -? (\"help\") displays this Help message.\n"
            "\n"
            "NOTE: this program does not respect read-only file attributes; they are reset\n"
            "if necessary to copy the files.\n"
            "\n"
            "EXAMPLE (back-up TLIB library files to a zip drive, F:):\n"
            "    tlibcopy -m c:\\tlib\\libs\\* f:\\tliblibs\\\n"
            "\n"
            "EXAMPLE (add -bb to back-up or restore the files to/from zip drive, F:):\n"
            "    tlibcopy -mbb c:\\tlib\\libs\\* f:\\tliblibs\\\n"
            "(yes, the exact same command can be used either to back-up or to restore)\n"
            "\n"
            "EXAMPLE (add -i for same thing, but also synchronize all sub-folders):\n"
            "    tlibcopy -mbbi c:\\tlib\\libs\\* f:\\tliblibs\\\n"
            "\n"
            "EXAMPLE (add -q for same thing, but quieter):\n"
            "    tlibcopy -mbbiq c:\\tlib\\libs\\* f:\\tliblibs\\\n"
            "\n"
            "EXAMPLE (add -t to not copy anything, just show what would be copied; this\n"
            "command recursively examines subdirectories, displaying a sample tlibcopy\n"
            "command that could be used to synchronize the files in each subdirectory):\n"
            "    tlibcopy -mbbiqt c:\\tlib\\libs\\* f:\\tliblibs\\\n"
            "\n"
            "EXAMPLE (synchronize TLIB library files on two computers, including all\n"
            "subdirectories):\n"
            "    tlibcopy -bbimq c:\\tlib\\libs\\* \\\\notebook\\d\\tlib\\libs\\\n"
            "\n"
            "EXAMPLE (add quote marks if paths contain spaces):\n"
            "    tlibcopy -bbimq \"c:\\my tlib libs\\*\" \"f:\\my tlib libs\\\"\n"
            "\n"
            "EXAMPLE (show this \"help message\" one screen-full at a time):\n"
            "    tlibcopy -h | more\n"
          );
  } /* give_help */


int quick_compare( FILE * file1, const char * file1name,
                   FILE * file2, const char * file2name,
                   const unsigned long amt_to_compare )
  {
   int result = 0;
   char bufr1[32768], bufr2[32768];
   unsigned long amt_left_to_compare=amt_to_compare, amt_compared_so_far=0L,
                 amt_to_rd, nbytes_rd1, nbytes_rd2;

    while ((0==result) && (amt_left_to_compare > 0))
      {
        if (amt_left_to_compare > 32768)
            amt_to_rd = 32768;
        else
            amt_to_rd = amt_left_to_compare;
        nbytes_rd1 = fread( bufr1, 1, amt_to_rd, file1 );
        if (nbytes_rd1 != amt_to_rd)
          {
            printf( "ERROR: read failure reading '%s', %s\n", file1name, strerror(errno) );
            result = 1;  /* error -- can't verify that the two files are identical */
          }
        nbytes_rd2 = fread( bufr2, 1, amt_to_rd, file2 );
        if (nbytes_rd2 != amt_to_rd)
          {
            printf( "ERROR: read failure reading '%s', %s\n", file2name, strerror(errno) );
            result = 1;  /* error -- can't verify that the two files are identical */
          }
        if (!result)
            result = memcmp( bufr1, bufr2, amt_to_rd );
        amt_left_to_compare -= amt_to_rd;
      } /*while*/
    return result;
  } /* quick_compare */


/* Append outfile with the tail of infile.  Returns 1 for error, 0 for success */
int copytail( FILE * infile_S, const char * infile_name,
              FILE * outfile_S, const char * outfile_name,
              unsigned long infile_size, const unsigned long outfile_size )
  {
   unsigned long nbytes_rd, nbytes_wr, amt_copied;
   char bufr[32768];
   int rc;

    fseek( infile_S, outfile_size, SEEK_SET );
    fseek( outfile_S, 0L, SEEK_END );
    /* note that this fseek() IS necessary when switching between reading and
       writing; see the MS VC/C++ documentation for fopen()
    */

    amt_copied = 0L;
    do {
        nbytes_rd = fread( bufr, 1, 32768, infile_S );
        if (nbytes_rd)
          {
            nbytes_wr = fwrite( bufr, 1, nbytes_rd, outfile_S );
            amt_copied += nbytes_wr;
            if (nbytes_wr != nbytes_rd)
              {
                printf( "ERROR: attempt to append to '%s' failed, only %lu of %lu bytes were written: %s\n",
                        outfile_name, nbytes_wr, nbytes_rd, strerror(errno) );
                my_fclose( infile_S );
                my_fclose( outfile_S );
                return 1;
              }
          }
    } while (nbytes_rd);

    my_fclose( infile_S );

    if (amt_copied != (infile_size - outfile_size))
      {
        printf( "ERROR: Tried to copy '%s' to '%s', adding %lu bytes, but only %lu bytes were actually added\n",
                infile_name, outfile_name, (infile_size - outfile_size), amt_copied );
        my_fclose( outfile_S );
        return 1;
      }

    rc = fflush( outfile_S );

    if (rc)
        printf( "ERROR: Tried to copy '%s' to '%s', adding %lu bytes, but fflush failed: %s\n",
                infile_name, outfile_name, (infile_size - outfile_size), strerror(errno) );
    else
      {
        if (verbosity >= dash_default_c)
          {
            printf( "Copied '%s' to '%s', %s%lu bytes\n",
                    infile_name, outfile_name, (outfile_size ? "adding " : ""), amt_copied );
          }
      }

    my_fclose( outfile_S );

    if (rc)
        return 1;
    return 0;
  } /* copytail */


/* Return subscript in str[] of last occurance of ch.  Return -1 if not found */
int lastposC(char ch, const char * s)
  {
   int result;
   char * tptr = strrchr( s, ch );
    if (tptr)
        result = tptr-s;
    else
        result = -1;
    return result;
  }  /* lastposC */


/* Return position of the last backslash or slash or colon in a string.
   Returns -1 for failure, or the index of the character for success (e.g.,
   if the first character in the string is a backslash, it returns "0").
   If we convert this program to Linux/Unix someday, we'll need to drop
   the ':' and backslash, and just look for '/'. */
int LastSlashOrColonC(const char * s)
  {
   int i, j;
    if (!s)
      {
        return -1;
      }
    i = lastposC(':',s);
    j = lastposC('\\',s);
    if (j > i)
        i = j;
    j = lastposC('/',s);
    if (j > i)
        i = j;
    return i;
  } /* LastSlashOrColonC */


/* True iff fpath[] ends is a backslash, slash, or colon.  If we convert this
   to Linux/Unix someday, we'll need to change this to just look for a '/'.  */
boolean_t ends_in_slash( const char * fpath )
  {
   int len = strlen(fpath);
    return (len && strchr(":\\/", fpath[len-1]));
  } /* ends_in_slash */


/* check whether fpath is a directory; if so, return true. */
boolean_t directory_exists( const char * fpath )
  {
   boolean_t result = false_c;
   HANDLE handle;
   WIN32_FIND_DATAA findbuf;

    memset( &findbuf, 0, sizeof(findbuf) );
    handle = FindFirstFile( fpath, &findbuf );
    if (INVALID_HANDLE_VALUE != handle)
      {
        if (((int)findbuf.dwFileAttributes) & FA_DIREC)
          { /* yes, it is a directory */
            result = true_c;
          }
        FindClose( handle );
      }
    return result;
  } /* directory_exists */


/* flag to ensure that only 1st mkdir failure is reported */
static int mkdir_err_reported = 0;

/* Input is the directory to MKDIR, with a backslash added to the end.
   Return 1 if we made it, else return 0 (perhaps because it already existed,
   or because it wasn't a legitimate directory name).  Set is_vol_name
   true if dir is of the form \\server\vol\, because an "already exists"
   error is usual with most networks when attempting to mkdir \\server\vol
   even if findfirst can't find it, so we should suppress the usual error
   messages.  */
static int make_one_dir( char * dir, boolean_t is_vol_name )
  {
   int len;
   int rc;  /* 0 == success */
   boolean_t it_exists;

    len = strlen( dir );
    if ((len <= 1) || ('\\' != dir[len-1]))
      {
        printf( "ERR: m1d (%s)\n", dir );
        return 0;
      }

    /* First, we screen out the pseudo-directories "D:" "\." and ".." */
    if (len >= 3)
      {
        if (':' == dir[len-2])
            return 0;  /* don't mkdir "D:" */
        if (strstr("..\\ \\.\\ :.\\", dir+len-3))
            return 0;  /* don't mkdir ".." or "\." or ":." */
      }
    else if ((2 == len) && !strcmp(".\\",dir))
        return 0;  /* don't mkdir "." */

    /* Next, screen out all already-made directories */

    /* Then make the directory */
    dir[len-1] = '\0';  /* zap the trailing backslask */
    it_exists = directory_exists( dir );

    /* we could skip the _mkdir() if it_exists==true, except that I don't trust
       the OS or network software to tell us the truth  :-(
    */

    _doserrno = 0;
    rc = _mkdir( dir );  /* 0=success */

    /* If -v or -vv, then display results of every mkdir attempt.  If -q or
       default, only display a message if we actually create a directory.
       If -qq then don't display any mkdir messages at all.
    */
    if (verbosity >= dash_v_c)
        printf( "mkdir \"%s\" %s.\n", dir, (rc ? "failed" : "succeeded") );
    else if (dash_q_c == verbosity)
      {
        if (0 == rc)
            printf( "mkdir \"%s\"\n", dir );
      }

    /* for some kinds of errors, we display an error message */
    if (rc && (!it_exists) && !mkdir_err_reported)
      {
        if (((183==_doserrno)||(EEXIST==errno)) && is_vol_name)  /* 183 is "directory already exists" */
            ; /* didn't really expect to be able to create //server/vol */
        else
          {
            if (183 == _doserrno) /* (errno == EEXIST=17) */
              { /* "directory already exists" error */
                printf( "ERR: mkdir(%s) failed with \"already exists\" error,\n"
                        "yet FindFirst can't find it.  Could be due to a hidden directory, or a\n"
                        "network ideosyncrasy.  _doserrno=%d, errno=%d.",
                        dir, _doserrno, errno );
              }
            else
                printf( "ERROR: mkdir(%s), _doserrno=%d, errno=%d.",
                        dir, _doserrno, errno );
            if (directory_exists(dir))
                printf( "  Dir now exists!?!" );
            printf("\n");
            mkdir_err_reported = 1;
          }
      }

    dir[len-1] = '\\';  /* restore */
    return (rc==0);
  } /* make_one_dir */

/* Input is the path of a file which we might want to create (the actual
   file name doesn't matter, and is ignored).  The directory in which the
   file will reside is created, if necessary, along with all parent
   directories.  Return 2 iff it made the last directory in the path;
   return 1 if made one or more earlier directories; return 0 if it
   successfully made no directories.  */
int make_all_dirs_needed( const char * path )
  {
   char * slashpos, * lastslash;
   char sav;
   boolean_t made_last_dir, made_at_least_one, netname, volname;
   filepath_t bufr;

    if (!path[0])
        return 0;  /* nothing to do */
    /* first, make copy of the path, with a blank at the beginning */
    my_strncpy( bufr, path, _MAX_PATH-1 );

    /* make all the directories mentioned in the path */
    netname = (('\\'==bufr[0]) && ('\\'==bufr[1]));
    if (netname)
      { /* \\node\path\name.ext -- don't try to make the node name */
        slashpos = lastslash = strchr( bufr+2, '\\' ); /* slash after "node" */
        if (slashpos)
            slashpos = strchr( slashpos+1, '\\' ); /* 1st slash within "path" */
      }
    else if (':'==bufr[1])
        slashpos = lastslash = strchr( bufr+3, '\\' );
    else
        slashpos = lastslash = strchr( bufr+1, '\\' );
    made_at_least_one = made_last_dir = false_c;
    mkdir_err_reported = 0;
    volname = netname;
    while (slashpos)
      {
        lastslash = slashpos;
        sav = slashpos[1];
        slashpos[1] = '\0';
        made_last_dir = make_one_dir( bufr, volname );
        made_at_least_one |= made_last_dir;
        slashpos[1] = sav;
        slashpos = strchr( slashpos+1, '\\' );
        volname = false_c;
      }/*for*/

    if (made_last_dir)
        return 2;
    return made_at_least_one;
  } /* make_all_dirs_needed */


long num_files_processed = 0;
long num_files_copied = 0;  /* number of files copied, or in -t mode the number of files that would be copied */


/* Examine two files; if they are identical except that one is longer than
   the other one, then perhaps append to the shorter one a copy of the the
   tail of the longer one, to make the two files identical.  If bothways is
   0, only file2 can be modified.  If bothways is >= 1, then the shorter of
   the two files can be modified, regardless of which file is shorter.  It
   returns a number that can be used as an errorlevel: 0 for success, 1 for
   error, 2 for a more severe error.  Global variables identical_files and
   num_files_copied are side-effect results. */
int cmpr_n_copy( const char * file1, const char * file2 )
  {
   const char * srcfile, * destfile;
   filepath_t file2_fixed;  /* _MAX_PATH is 260 for MS Windows 9x/Me/NT/2K/XP */
   FILE * file1_S, * file2_S, * srcfile_S, * destfile_S;  /* the S stands for "stream" */
   unsigned long file1_size, file2_size, srcfile_size, destfile_size, tmp_size;
   boolean_t file1_writable=false_c, file2_writable=false_c, destfile_writable=false_c;
   int rc = 0;

    /* Open first file for reading, and check its length */

    file1_S = fopen(file1,"rb");
    if (!file1_S)
      {
        if ((errno != ENOENT /*2*/) || !bothways)
          {
            printf( "ERROR: could not open '%s', errno=%d, %s\n", file1, errno, strerror(errno) );
            return 2;
          }
        /* no file is okay, if -b was specified -- we'll just copy file2 to file1 */
        file1_size = 0;
        /* if -b specified, then missing file1 is okay */
      }
    else
      {
        rc = fseek( file1_S, 0L, SEEK_END );
        if (rc)
          {
            printf( "ERROR: fseek failed for '%s'\n", file1 );
            my_fclose( file1_S );
            return 2;
          }
        file1_size = ftell( file1_S );
      }

    /* if file2 is a directory, then append the file name from file1 */
    if (strchr(":\\/", file2[strlen(file2)-1] ))
      {
        const char * fname1 = file1 + 1 + LastSlashOrColonC( file1 );
        my_strncpy( file2_fixed, file2, _MAX_PATH-1 );
        my_strncat( file2_fixed, fname1, _MAX_PATH-1 );
        file2 = file2_fixed;
      }

    /* open 2nd file, either for reading or for read/write */
    if (bothways || testmode)
      { /* -b option was specified, so open both files just for reading, initially */
        file2_S = fopen(file2, "rb" );  /* "rb" is for read-only, binary mode */
        if (!file2_S)
          {
            if (errno != ENOENT /*2*/)
              { /* any error except "file not found" */
                printf( "ERROR: could not open '%s', errno=%d, %s\n", file2, errno, strerror(errno) );
                my_fclose( file1_S );
                return 2;
              }
            /* file not found is okay*/
            file2_size = 0;
            if (0 == file1_size)
              {
                printf( "ERROR: neither file exists with a non-zero length: '%s' and '%s'\n",
                        file1, file2 );
                my_fclose( file1_S );
                return 2;
              }
          }
      }
    else
      { /* neither -b nor -t option was not specified, so open 2nd file for
           read/write if possible, and create if missing */
        file2_S = fopen(file2, "a+b" );  /* "a+b" is read+append, binary mode; create if missing */
        if (file2_S)
            file2_writable = true_c;
        else
          { /* 2nd try is to open for read */
            file2_S = fopen(file2, "rb" );  /* "rb" is read-only, binary mode -- might work if file was read-only */
            if ((!file2_S) && makedirs)
              { /* That didn't work, either.  Make any missing directories and try again. */
                make_all_dirs_needed( file2 );
                file2_S = fopen(file2, "a+b" );
                if (file2_S)
                    file2_writable = true_c;
              }
            if (!file2_S)
              {
                printf( "ERROR: could not open '%s', errno=%d, %s\n", file2, errno, strerror(errno) );
                my_fclose( file1_S );
                return 2;
              }
          }
      }
    if (file2_S)
      {
        rc = fseek( file2_S, 0L, SEEK_END );
        if (rc)
          {
            printf( "ERROR: fseek failed for '%s'\n", file2 );
            my_fclose( file1_S );
            my_fclose( file2_S );
            return 2;
          }
        file2_size = ftell( file2_S );
      }
    if (verbosity >= dash_vv_c)
        printf("'%s' is %lu bytes, '%s' is %lu bytes\n", file1, file1_size, file2, file2_size );

    /* decide which way we're copying, based on file sizes and -b option */
    if (    bothways
         && (   (file1_size < file2_size)  /* normal case */
             || ((0L==file2_size) && !file1_S)  /* case of 0-length file2 & missing file1 */
        ))
      {
        srcfile = file2;
        srcfile_S = file2_S;
        file2_S = NULL;
        destfile = file1;
        destfile_S = file1_S;
        file1_S = NULL;
        srcfile_size = file2_size;
        destfile_size = file1_size;
        destfile_writable = false_c;
      }
    else
      {
        srcfile = file1;
        srcfile_S = file1_S;
        file1_S = NULL;
        destfile = file2;
        destfile_S = file2_S;
        file2_S = NULL;
        srcfile_size = file1_size;
        destfile_size = file2_size;
        destfile_writable = file2_writable;
      }

    /* from now on, we use srcfile and destfile, rather than file1 and file2,
       since we now know which file is the source and which is destination */

    if (srcfile_size < destfile_size)
      { /* only possible if bothways==0 */
        if (verbosity >= dash_default_c)  /* -q can suppress this one */
            printf( "Failed: '%s' is shorter than '%s'\n", srcfile, destfile );
        my_fclose( srcfile_S );
        my_fclose( destfile_S );
        return 1;
      }

    fseek( srcfile_S, 0L, SEEK_SET );
    if (destfile_S)
      {
        fseek( destfile_S, 0L, SEEK_SET );
        /* destfile might not be open, if it doesn't exist and testmode is true;
          but in that case quick_compare won't try to read it because destfile_size=0 */
      }
    rc = quick_compare( srcfile_S, srcfile, destfile_S, destfile, destfile_size );
    if (0 != rc)
      { /* files didn't match */
        if (srcfile_size == destfile_size)
            printf( "Failed: '%s' and '%s' are the same size, but are not identical.\n", file1, file2 );
        else
            printf( "Failed: The first %lu bytes of %s' are not identical to '%s'\n", file2_size, file1, file2 );
        my_fclose( file1_S );
        my_fclose( file2_S );
        return 1;
      }

    if (srcfile_size == destfile_size)
      {
        if (verbosity >= dash_v_c)  /* suppressed unless -v specified */
            printf( "Files were already identical: %s' and '%s'\n", srcfile, destfile );
        my_fclose( srcfile_S );
        my_fclose( destfile_S );
        return 0;
      }

    /* okay, if we get this far then it means that we need to append the tail
       of file1 onto the end of file2 (except for -t testmode, of course) */

    if (testmode)
      {
        if (verbosity >= dash_default_c)
          {
            printf( "Would copy '%s' to '%s', %s%lu bytes\n",
                    srcfile, destfile, (destfile_size ? "adding " : ""),
                    (srcfile_size-destfile_size) );
          }
        my_fclose( srcfile_S );
        my_fclose( destfile_S );
        num_files_copied++;
        rc = 0;
      }
    else
      {
        /* if it was open in "rb" mode, then close it and immediately reopen it in "a+b" (append) mode */
        if (!destfile_writable)
          {
            my_fclose( destfile_S );
            destfile_S = fopen( destfile, "a+b" );  /* "a+b" is read+append, binary mode; create if missing */
            if ((!destfile_S) /* && (EACCES == errno) */ )
              { /* reset the read-only attribute and retry */
                (void)SetFileAttributes( destfile, FILE_ATTRIBUTE_ARCHIVE|FILE_ATTRIBUTE_NORMAL /*0x00A0*/ );
                destfile_S = fopen( destfile, "a+b" );
              }

            if ((!destfile_S) && makedirs)
              { /* make any missing directories and retry */
                make_all_dirs_needed( destfile );
                destfile_S = fopen( destfile, "a+b" );  /* "a+b" is read+append, binary mode; create if missing */
              }

            if (!destfile_S)
              {
                printf( "ERROR: could not open '%s' for writing, errno=%d, %s\n", destfile, errno, strerror(errno) );
                my_fclose( srcfile_S );
                my_fclose( destfile_S );
                return 2;
              }
            destfile_writable = true_c;
            rc = fseek( destfile_S, 0L, SEEK_END );  /* seek to end */
            if (rc)
              {
                printf( "ERROR: 2nd fseek failed for '%s'\n", destfile );
                my_fclose( srcfile_S );
                my_fclose( destfile_S );
                return 2;
              }
            tmp_size = ftell( destfile_S );
            if (tmp_size != destfile_size)  /* size of file should not have changed */
              {
                printf( "ERROR: size of '%s' changed from %lu to %lu!?!\n",
                        destfile, destfile_size, tmp_size );
                my_fclose( srcfile_S );
                my_fclose( destfile_S );
                return 2;
              }
          }

        rc = copytail( srcfile_S, srcfile, destfile_S, destfile, srcfile_size, destfile_size );
        /* Note that copytail closes the files.  rc is the errorlevel, 0=success. */

        if (!rc)
            num_files_copied++;
      }

    return rc;
  } /* cmpr_n_copy */


/* If fpath ends in a backslash (or slash or colon), just return false.
   If not, check whether it is a directory; if so, return true. */
boolean_t is_directory_sans_trailing_backslash( const char * fpath )
  {
   boolean_t result = false_c;

    if ((!ends_in_slash(fpath)) && directory_exists(fpath))
        result = true_c;

    return result;
  } /* is_directory_sans_trailing_backslash */


/* Correct common problems with quoted paths, from which cmd.exe has
   (supposedly) removed the quote marks */
int massage_a_path( filepath_t fpath )
  {
   int len = strlen(fpath);

    /* Remove trailing blanks, if any.  File names may not end in blanks, but
       a command line parameter could end in blanks if the user quoted it.
    */
    while (len && (' ' == fpath[len-1]))
        fpath[--len] = '\0';

    /* Double-quote marks are prohibited in file names under Windows, so if
       there is a double-quote mark at the end it is probably because the
       user specified something like
         "c:\tlib libs\subdir\"
       (including the quote marks), and cmd.exe took the trailing backslash
       as an escape character to include the literal quote.  So here I just
       replace the quote mark with a backslash.
    */
    if (len)
      {
        if ('"' == fpath[len-1])
            fpath[len-1] = '\\';
      }
    return len;
  } /* massage_a_path */


int massage_target_dir( filepath_t tgt )
  {
   int len = massage_a_path( tgt );

    if (len)
      {
        /* In general, we don't permit wild-cards in the output file spec,
           but if the wildcard spec is "*" or "*.*" we handle it has a
           special case (we just remove the wild-card spec and leave the
           directory, ending in a backslash).
        */
        if ('*' == tgt[len-1])
          {
            if ((1 == len) || !strcmp("*.*",tgt))
              {
                strcpy( tgt, ".\\" );
                len = 2;
              }
            else if ((len >= 2) && !strcmp("\\*",tgt+len-2))
                tgt[--len] = '\0';
            else if ((len >= 4) && !strcmp("\\*.*",tgt+len-4))
              {
                len -= 3;
                tgt[len] = '\0';
              }
          }
      }
    return len;
  } /* massage_target_dir */


/* Compare & perhaps copy files matching file1 to files in file2.  file2 should
   be a directory.
   As a side-effect, this function increments num_files_processed for each file
   it finds, and (by calling cmpr_n_copy) increments num_files_copied for each
   file that it updates */
int wildcard_cmpr_n_copies( filepath_t file1, filepath_t file2 )
  {
   WIN32_FIND_DATAA findbuf;
   HANDLE handle;
   filepath_t found;
   char * search_for = NULL;
   int tmp_rc, rc, f_rc, src_last_slash;

    rc = 0;
    search_for = file1;
    src_last_slash = LastSlashOrColonC( search_for );
    if (src_last_slash > (_MAX_PATH-3))
        src_last_slash = _MAX_PATH-2;
    memset( &findbuf, 0, sizeof(findbuf) );
    handle = FindFirstFile( search_for, &findbuf );
    if (INVALID_HANDLE_VALUE == handle)
        f_rc = -1;  /* failure */
    else
        f_rc = 0;  /* success */

    while (0 == f_rc)
      {
        /* Win32 findfirst/findnext don't filter for the file attributes,
           so we must do it ourselves. */
        if (0 == (((int)findbuf.dwFileAttributes) & (FA_DIREC|FA_LABEL|FA_HIDDEN|FA_SYSTEM)))
          { /* skip Labels, Directories, Hidden files, and System files */

            my_strncpy( found, search_for, 1+src_last_slash );
            my_strncat( found, findbuf.cFileName, _MAX_PATH-1 );

            /* here's where we do the work */
            tmp_rc = cmpr_n_copy( found, file2 );

            num_files_processed++;
            if (tmp_rc > rc)
                rc = tmp_rc;  /* errorlevel is the worst seen for all files attempted */
          }

        if (FindNextFile( handle, &findbuf ) && findbuf.cFileName[0])
            f_rc = 0;  /* success */
        else
            f_rc = -1;  /* failure */
      }/*while*/

    if (INVALID_HANDLE_VALUE != handle)
      {
        FindClose( handle );
        handle = INVALID_HANDLE_VALUE;
      }
    return rc;
  } /* wildcard_cmpr_n_copies */


/* compute a case-insensitive hashcode (table index) of specified size */
int hashcode( const char * name, int indexbits )
  {
   int result = 0, ch, cntr=0, foldat, len;
   const char * namptr;
     if ((!name) || !*name)
         return 0;
     len = strlen(name);
     namptr = name;
#if FLAT32
     if (indexbits <= 6)
         foldat = 5;
     else if (indexbits >= 12)
         foldat = 11;
#else
     if (indexbits <= 4)
         foldat = 3;
     else if (indexbits >= 9)
         foldat = 8;
#endif
     else
         foldat = indexbits - 1;
     foldat += 1;
     while ('\0' != (ch=*namptr++))
       {
         ch = toupper(ch);
         result = ((result << 1) ^ ch);
         if (++cntr >= foldat)
           {
             result ^= (result >> foldat);
             cntr = 0;
           }
       }/*while*/
    result ^= (result >> 17);
    result ^= *(unsigned short *)name;
    result &= ((1 << indexbits) - 1);
    return result;
  } /* hashcode */


struct list_of_names_s {
      struct list_of_names_s * nxt;
      char name[1];  /* actually always longer than that */
  };
typedef struct list_of_names_s list_of_names_t;
typedef list_of_names_t * ptr_to_list_of_names_t;


/* these are the paths of the top-level 'file1' and 'file2' directories */
filepath_t top_file1_dir;  /* the part of file1 up to and including the last slash */
filepath_t top_file2_dir;  /* the part of file2 up to and including the last slash */
filepath_t wcspec;  /* the part of file1 after the last slash */
filepath_t target_file_sans_dir;  /* the part of file2 after the last slash (usually nothing) */
filepath_t this_subdir;  /* 0-length except when processing subdirectories ('-i'),
                            in which case it ends with a backslash but does not begin with one */

/* for -i mode, the heap-resident list of yet-to-be-processed subdirs,
   all relative to top_file1_dir[] and top_file2_dir[].  */
ptr_to_list_of_names_t dir_list = NULL, dir_list_tail = NULL;


struct hashtableentry_s {
      struct hashtableentry_s * nxt;
      ptr_to_list_of_names_t nameptr;
    };
typedef struct hashtableentry_s hashtableentry_t;
typedef struct hashtableentry_s * ptr_to_hashtableentry_t;

/* allocate a hashtableentry_t on the stack, copy nam[] into it, and set tmp to its addres */
#define new_name_struct_on_stack_m(nam) {newptr=_alloca(sizeof(list_of_names_t)+strlen(nam)); if (newptr) {newptr->nxt=NULL; strcpy(newptr->name,nam);}}

/* Add a hashtableentry_t to a linked list of them.  Return true for success, false if newptr==NULL. */
boolean_t add_to_linked_list( ptr_to_list_of_names_t newptr,
                              ptr_to_list_of_names_t * listroot,
                              ptr_to_list_of_names_t * listtail )
  {
    if (!newptr)
      {
        printf( "ERROR: mem alloc failed, some files will be skipped\n" );
        return false_c;
      }
    newptr->nxt = NULL;
    if (*listtail)
        (*listtail)->nxt = newptr;
    else
        *listroot = newptr;
    (*listtail) = newptr;
    return true_c;
  } /* add_to_linked_list */


/* This function is used only rarely, to remove a file name from a file name
   list if it is the same as a subdirectory name in the other directory, or to
   remove a subdirectory name from a directory name list if it is the same as
   a plain file name in the the other directory.  Beause the removed list
   element is on the stack, there's no 'freeing' step; the storage will be
   recovered when the main function returns.  Because this function is rarely
   called, I didn't bother to try to make it fast.  */
void remove_from_linked_list( ptr_to_list_of_names_t * pLinkedList,  const char * name )
  {
   ptr_to_list_of_names_t tmp_ptr, *prev_ptr;
    prev_ptr = pLinkedList;
    tmp_ptr = *prev_ptr;
    while (tmp_ptr)
      {
        if (!stricmp(name,tmp_ptr->name))
          {
            (*prev_ptr) = tmp_ptr->nxt;
            return;
          }
        prev_ptr = &(tmp_ptr->nxt);
        tmp_ptr = tmp_ptr->nxt;
      }
    printf( "ERR: could not remove '%s' from linked list\n", name );
  } /* remove_from_linked_list */


/* Input is a name list (on the stack, at least for now).  This function builds
   a hashtable on the heap.  Result is a pointer to the malloc'd hashtable
   array.  The number of bits in the table index bitmask is also a result:
   *pIndexbits.  You can compute the hash table size as (1 << indexbits).  */
ptr_to_hashtableentry_t * make_a_hashtable( ptr_to_list_of_names_t namelist, int num_names,
                                            int * pIndexbits )
  {
   int hashtablesize, indexbits, ndx;
   ptr_to_list_of_names_t tmp;
   ptr_to_hashtableentry_t hptr;
   ptr_to_hashtableentry_t *hashtable; /* function result - pointer to a malloc'd array */

    /* pick a hash table size that is appropriate for the number of names */
    hashtablesize = 1;
    indexbits = 0;
    while (hashtablesize < ((4*num_names)/5))
      {
        hashtablesize *= 2;
        indexbits++;
        if (0 == hashtablesize)
          { /* avoid endless loop if huge number of names */
            indexbits -= 4;
            hashtablesize = (1 << indexbits);
            break;
          }
      }/*while*/

    /* create the hash table */
    for (;;)
      {
        hashtable = malloc( hashtablesize * sizeof(ptr_to_hashtableentry_t) );
        if (hashtable)
            break;
        hashtablesize >>= 1;
        if (!hashtablesize)
            break;  /* hashtablesize=0, indexbits=0, hashtable=NULL */
        indexbits--;
      }
    if (hashtable)
      {
        memset( hashtable, 0, hashtablesize * sizeof(ptr_to_hashtableentry_t) );

        /* populate the hash table */
        tmp = namelist;
        while (tmp)
          {
            ndx = hashcode( tmp->name, indexbits );
            hptr = malloc( sizeof(hashtableentry_t) );
            if (hptr)
              {
                hptr->nxt = hashtable[ndx];
                hptr->nameptr = tmp;
                hashtable[ndx] = hptr;
              }
            tmp = tmp->nxt;
          }/*while*/
      }

    /* hashtablesize = (1 << indexbits) */
    *pIndexbits = indexbits;
    return hashtable;
  } /* make_a_hashtable */


/* free a hash table */
void free_hash_table( ptr_to_hashtableentry_t *hashtable, int indexbits )
  {
   int ndx;
   ptr_to_hashtableentry_t hptr, tmp_hptr;
   int hashtablesize = (1 << indexbits);

    if (hashtable)
      {
        for (ndx=0; ndx < hashtablesize; ndx++)
          {
            hptr = hashtable[ndx];
            hashtable[ndx] = NULL;
            while (hptr)
              {
                tmp_hptr = hptr->nxt;
                hptr->nxt = NULL;
                hptr->nameptr = NULL;  /* no need to free name because it is on the stack */
                free( hptr );
                hptr = tmp_hptr;
              }
          }/*for*/
        free( hashtable );
      }/*if*/
  } /* free_hash_table */


/* Look up a name in a hash table; if found return a pointer to the hash
   table entry, otherwise return NULL. */
ptr_to_hashtableentry_t lookup_in_hashtable( ptr_to_hashtableentry_t * hashtable, int indexbits,
                                             const char * name )
  {
   ptr_to_hashtableentry_t hptr;
   int ndx;
     if (!hashtable)
         return NULL;
     ndx = hashcode( name, indexbits );
     hptr = hashtable[ndx];
     while (hptr)
       {
         /* for case-sensitive file systems (Unix/Linux), we'll have to change stricmp to strcmp */
         if (!stricmp( hptr->nameptr->name, name ))
             break;  /* name was already in hash table */
         hptr = hptr->nxt;
       }
     /* at this point, hptr=NULL means name was not in hash table */
     return hptr;
  } /* lookup_in_hashtable */


/* true iff dname[] is "." or ".." */
boolean_t dot_or_double_dot( const char * dname )
  {
    return (   ('.' == dname[0])
            && (   ('\0' == dname[1])
                || (   ('.' == dname[1])
                    && ('\0' == dname[2]))));
  } /* dot_or_double_dot */


/* as a side-effect, this increments num_files_processed for each file it
   finds */
int wildcard_cmpr_n_copies_both_ways(
                  filepath_t top_file1_dir, filepath_t top_file2_dir,
                  filepath_t this_subdir, filepath_t wcspec,
                  filepath_t target_file_sans_dir )
  {
   WIN32_FIND_DATAA findbuf;
   HANDLE handle;
   filepath_t found;
   filepath_t search_for;
   filepath_t file2;
   int tmp_rc, rc, f_rc, num_names;
   ptr_to_list_of_names_t namelist = NULL, namelist_tail = NULL, newptr, tmp;
   ptr_to_hashtableentry_t *hashtable, hptr;
   int indexbits;
   int num_addl, num_dups;
   int num_dirs;
   ptr_to_list_of_names_t dirlist = NULL, dirlist_tail = NULL;
   ptr_to_hashtableentry_t *dir_hashtable;
   int dir_indexbits;
   boolean_t must_search_twice;  /* false if wildcard spec is "*" or -i is not specified */
   DWORD find_mask;

    if (!dosubdirs)
      { /* no '-i' option, so exclude all subdirectories */
        find_mask = FA_DIREC|FA_LABEL|FA_HIDDEN|FA_SYSTEM;  /* these are the attributes we exclude */
        must_search_twice = false_c;  /* means we don't need an extra search to find directories */
      }
    else if (!strcmp("*",wcspec))
      { /* They specified the '-i' option and "*" for a wildcard spec, so we
           can search for both file names a directories at the same time */
        find_mask = FA_LABEL|FA_HIDDEN|FA_SYSTEM;
        must_search_twice = false_c;  /* means we can find files and directories at the same time */
      }
    else
      { /* they specified '-i' so we must find the subdirectories, but they
           are using a wildcard spec other than "*", so we'll have to use a
           separate search to find the subdirectories */
        find_mask = FA_DIREC|FA_LABEL|FA_HIDDEN|FA_SYSTEM;
        must_search_twice = true_c;  /* means we have to use a separate search for directories */
      }

    rc = 0;
    num_names = 0;
    num_dirs = 0;

    if (verbosity >= dash_q_c)
        printf( "tlibcopy %s\"%s%s%s\" \"%s%s%s\"\n", option_str,
                  top_file1_dir, this_subdir, wcspec,
                  top_file2_dir, this_subdir, target_file_sans_dir );


    /* STEP #1: expand wildards in the file1 directory */

    strcpy( search_for, top_file1_dir );
    my_strncat( search_for, this_subdir, _MAX_PATH-1 );
    my_strncat( search_for, wcspec, _MAX_PATH-1 );

    memset( &findbuf, 0, sizeof(findbuf) );
    handle = FindFirstFile( search_for, &findbuf );
    if (INVALID_HANDLE_VALUE == handle)
        f_rc = -1;  /* failure */
    else
        f_rc = 0;  /* success */
    while (0 == f_rc)
      {
        /* Win32 findfirst/findnext don't filter for the file attributes,
           so we must do it ourselves. */
        if (0 == (((int)findbuf.dwFileAttributes) & find_mask))
          { /* skip Volume Labels, Hidden files, System files, and perhaps directories */
            /* it is either a plain file or a directory (but it can only be a
               directory if must_search_twice=false_c and dosubdirs=true_c) */

            if (!dot_or_double_dot(findbuf.cFileName))  /* skip '.' and '..' */
              {
                /* save the name in a (struct list_of_names_s) on the stack */
                new_name_struct_on_stack_m( findbuf.cFileName );
                /* result is newptr, a pointer to a filled-in structure on the stack */

                if (newptr)
                  {
                    if (0 == (((int)findbuf.dwFileAttributes) & FA_DIREC))
                      { /* plain file */
                        add_to_linked_list( newptr, &namelist, &namelist_tail );
                        num_names++;
                      }
                    else
                      { /* directory */
                        add_to_linked_list( newptr, &dirlist, &dirlist_tail );
                        num_dirs++;
                      }
                  }
                else
                  { /* _alloca() failed */
                    f_rc = -2;
                    break;
                  }
              }
          }/*while*/

        if (FindNextFile( handle, &findbuf ) && findbuf.cFileName[0])
            f_rc = 0;  /* success */
        else
            f_rc = -1;  /* failure */
      }/*while*/
    if (INVALID_HANDLE_VALUE != handle)
      {
        FindClose( handle );
        handle = INVALID_HANDLE_VALUE;
      }

    if (verbosity >= dash_default_c)
      {
        printf( "Found %d names by searching '%s'\n", num_names, search_for );
        fflush(stdout);
      }

    if (must_search_twice)
      { /* search for the subdirectories */
        if (num_dirs)
            printf( "ERR: num_dirs=%d, must_search_twice=%d\n", num_dirs, must_search_twice );
        memset( &findbuf, 0, sizeof(findbuf) );

        strcpy( search_for, top_file1_dir );
        my_strncat( search_for, this_subdir, _MAX_PATH-1 );
        my_strncat( search_for, "*", _MAX_PATH-1 );

        handle = FindFirstFile( search_for, &findbuf );
        if (INVALID_HANDLE_VALUE == handle)
            f_rc = -1;  /* failure */
        else
            f_rc = 0;  /* success */
        while (0 == f_rc)
          {
            /* Win32 findfirst/findnext don't filter for the file attributes,
               so we must do it ourselves. */
            if (FA_DIREC == (((int)findbuf.dwFileAttributes) & (FA_DIREC|FA_LABEL|FA_HIDDEN|FA_SYSTEM)))
              { /* skip Volume Labels, normal files, Hidden directories, and System directories */
                if (!dot_or_double_dot(findbuf.cFileName))  /* skip '.' and '..' */
                  {
                    /* save the name in a (struct list_of_names_s) on the stack */
                    new_name_struct_on_stack_m( findbuf.cFileName );
                    /* result is newptr, a pointer to a filled-in structure on the stack */
                    if (newptr)
                      {
                        add_to_linked_list( newptr, &dirlist, &dirlist_tail );
                        num_dirs++;
                      }
                    else
                      { /* _alloca() failed */
                        f_rc = -2;
                        break;
                      }
                  }
              }

            if (FindNextFile( handle, &findbuf ) && findbuf.cFileName[0])
                f_rc = 0;  /* success */
            else
                f_rc = -1;  /* failure */
          }/*while*/
        if (INVALID_HANDLE_VALUE != handle)
          {
            FindClose( handle );
            handle = INVALID_HANDLE_VALUE;
          }
      }/*if*/


    /* STEP #2: expand wildards in the file2 directory, if -bb was specified.
       To avoid duplicating names, this we use a temporary hash table
       containing the names found in step 1.
    */

    tmp_rc = 0;
    if ((bothways >= 2) && (f_rc != -2))
      { /* -bb is specified, so append the wildcard spec to file2 and search for more files */

        /* first, build a hash table containing the file names we've already found */
        hashtable = make_a_hashtable( namelist, num_names, &indexbits );

        /* also, build a hash table with the directories, if -i was specified */
        dir_hashtable = NULL;
        if (dirlist)  /* dirlist != NULL implies that dosubdirs is true */
            dir_hashtable = make_a_hashtable( dirlist, num_dirs, &dir_indexbits );

        num_addl = 0;
        num_dups = 0;

        strcpy( search_for, top_file2_dir );
        my_strncat( search_for, this_subdir, _MAX_PATH-1 );
        my_strncat( search_for, wcspec, _MAX_PATH-1 );

        memset( &findbuf, 0, sizeof(findbuf) );
        handle = FindFirstFile( search_for, &findbuf );
        if (INVALID_HANDLE_VALUE == handle)
            f_rc = -1;  /* failure */
        else
            f_rc = 0;  /* success */
        while (0 == f_rc)
          {
            /* Win32 findfirst/findnext don't filter for the file attributes,
               so we must do it ourselves. */

            if (0 == (((int)findbuf.dwFileAttributes) & find_mask))
              { /* skip Labels, Hidden files, System files, and perhaps directories */

                if (0 == (((int)findbuf.dwFileAttributes) & FA_DIREC))
                  { /* plain file */
                    /* ** now check that the new name wasn't one of the old names ** */
                    hptr = lookup_in_hashtable( hashtable, indexbits, findbuf.cFileName );
                    if (hptr)
                        num_dups++;
                    else
                      {
                        if (dosubdirs)
                          {
                            hptr = lookup_in_hashtable( dir_hashtable, dir_indexbits, findbuf.cFileName );
                            if (hptr)
                              {
                                printf( "ERROR: '%s' ignored because it is a directory in '%s%s' but a plain file in '%s%s'\n",
                                        findbuf.cFileName,
                                        top_file1_dir, this_subdir,
                                        top_file2_dir, this_subdir );
                                /* remove directory from list of directories */
                                remove_from_linked_list( &dirlist,  findbuf.cFileName );
                              }
                          }
                      }
                    if (!hptr)
                      { /* add name to linked list (on stack) */
                        num_addl++;
                        new_name_struct_on_stack_m( findbuf.cFileName );
                        /* result is newptr, a pointer to a filled-in structure on the stack */
                        if (add_to_linked_list( newptr, &namelist, &namelist_tail ))
                            num_names++;
                        else
                          { /* _alloca() failed, out of stack space */
                            f_rc = -2;
                            tmp_rc = 2;
                            break;
                          }
                      }
                  }
                else
                  { /* directory (and -i was specified, so dosubdirs=true) */
                    if (!dot_or_double_dot(findbuf.cFileName))  /* skip '.' and '..' */
                      {
                        /* ** now check that the new name wasn't one of the old names ** */
                        hptr = lookup_in_hashtable( dir_hashtable, dir_indexbits, findbuf.cFileName );
                        if (hptr)
                            /* num_dup_dirs++ */;
                        else
                          {
                            hptr = lookup_in_hashtable( hashtable, indexbits, findbuf.cFileName );
                            if (hptr)
                              {
                                printf( "ERROR: '%s' ignored because it is a plain file in '%s%s' but a directory in '%s%s'\n",
                                        findbuf.cFileName,
                                        top_file1_dir, this_subdir,
                                        top_file2_dir, this_subdir );
                                /* remove directory from list of directories */
                                remove_from_linked_list( &namelist,  findbuf.cFileName );
                              }
                          }
                        if (!hptr)
                          { /* add name to linked list (on stack) */
                            /* num_addl_dirs++; */
                            new_name_struct_on_stack_m( findbuf.cFileName );
                            /* result is newptr, a pointer to a filled-in structure on the stack */
                            if (add_to_linked_list( newptr, &dirlist, &dirlist_tail ))
                                num_dirs++;
                            else
                              {
                                f_rc = -2;
                                tmp_rc = 2;
                                break;
                              }
                          }
                      }
                  }
              }/*if*/
            if (FindNextFile( handle, &findbuf ) && findbuf.cFileName[0])
                f_rc = 0;  /* success */
            else
                f_rc = -1;  /* failure */
          }/*while*/
        if (INVALID_HANDLE_VALUE != handle)
          {
            FindClose( handle );
            handle = INVALID_HANDLE_VALUE;
          }

        if (verbosity >= dash_default_c)
          {
            printf( "Found %d more names (and %d duplicats) by searching '%s%s'\n",
                    num_addl, num_dups, top_file2_dir, this_subdir );
            fflush(stdout);
          }

        if (must_search_twice)
          { /* search for the subdirectories */
            strcpy( search_for, top_file2_dir );
            my_strncat( search_for, this_subdir, _MAX_PATH-1 );
            my_strncat( search_for, "*", _MAX_PATH-1 );

            memset( &findbuf, 0, sizeof(findbuf) );
            handle = FindFirstFile( search_for, &findbuf );
            if (INVALID_HANDLE_VALUE == handle)
                f_rc = -1;  /* failure */
            else
                f_rc = 0;  /* success */
            while (0 == f_rc)
              {
                if (FA_DIREC == (((int)findbuf.dwFileAttributes) & (FA_DIREC|FA_LABEL|FA_HIDDEN|FA_SYSTEM)))
                  { /* skip Volume Labels, normal files, Hidden directories, and System directories */
                    if (!dot_or_double_dot(findbuf.cFileName))  /* skip '.' and '..' */
                      {
                        /* ** now check that the new name wasn't one of the old names ** */
                        hptr = lookup_in_hashtable( dir_hashtable, dir_indexbits, findbuf.cFileName );
                        if (hptr)
                            /* num_dup_dirs++ */;
                        else
                          {
                            hptr = lookup_in_hashtable( hashtable, indexbits, findbuf.cFileName );
                            if (hptr)
                              {
                                printf( "ERROR: '%s' ignored because it is a plain file in '%s%s' but a directory in '%s%s'\n",
                                        findbuf.cFileName,
                                        top_file1_dir, this_subdir,
                                        top_file2_dir, this_subdir );
                                /* remove directory from list of plain files */
                                remove_from_linked_list( &namelist,  findbuf.cFileName );
                              }
                          }
                        if (!hptr)
                          { /* add name to linked list (on stack) */
                            /* num_addl_dirs++; */
                            new_name_struct_on_stack_m( findbuf.cFileName );
                            /* result is newptr, a pointer to a filled-in structure on the stack */
                            if (add_to_linked_list( newptr, &dirlist, &dirlist_tail ))
                                num_dirs++;
                            else
                              {
                                f_rc = -2;
                                tmp_rc = 2;
                                break;
                              }
                          }
                      }
                  }/*if*/
                if (FindNextFile( handle, &findbuf ) && findbuf.cFileName[0])
                    f_rc = 0;  /* success */
                else
                    f_rc = -1;  /* failure */
              }/*while*/
            if (INVALID_HANDLE_VALUE != handle)
              {
                FindClose( handle );
                handle = INVALID_HANDLE_VALUE;
              }
          }/*if*/

        /* return the hash table(s) to the heap */
        free_hash_table( hashtable, indexbits );
        hashtable = NULL;
        if (dir_hashtable)
          {
            free_hash_table( dir_hashtable, dir_indexbits );
            dir_hashtable = NULL;
          }

      }/*if*/

    if (tmp_rc > rc)  /* in case _alloca() failed */
        rc = tmp_rc;  /* errorlevel is the worst seen for all files attempted */

    /* Okay, at this point namelist is a linked list (on the stack) of all
       the file names we found */


    /* STEP #3: compare & copy the files found in steps 1 and 2 */

    strcpy( file2, top_file2_dir );
    my_strncat( file2, this_subdir, _MAX_PATH-1 );
    my_strncat( file2, target_file_sans_dir, _MAX_PATH-1 );
    /* target_file_sans_dir is 0-length except for one special case:
       when file1 doesn't contain wildcards but -i is specified and a
       target filename is also specified.  Example:
         tlibcopy -bi c:\journal.dat c:\journal.bak
    */
    tmp = namelist;
    while (tmp)
      {
        strcpy( found, top_file1_dir );
        my_strncat( found, this_subdir, _MAX_PATH-1 );
        my_strncat( found, tmp->name, _MAX_PATH-1 );

        /* here's where we do the work */
        tmp_rc = cmpr_n_copy( found, file2 );

        num_files_processed++;
        if (tmp_rc > rc)
            rc = tmp_rc;  /* errorlevel is the worst seen for all files attempted */
        tmp = tmp->nxt;
        /* No need to free the storage, because it is on the stack, so it'll
           be freed when the function exits.  If we'd used malloc() then we'd
           have to free it here.
        */
      }/*while*/


    /* STEP 4: if -i was specified, then copy the list of directories from the
       stack to the heap before exiting.
    */

    if (dirlist)
      {
        tmp = dirlist;
        while (tmp)
          {
            /* The stack-based list that we have at dirlist has only bare
               subdirectory names; the heap-based list at dir_list also has
               this_subdir prefixed to it.  */
            my_strncpy( found, this_subdir, _MAX_PATH-1 );
            my_strncat( found, tmp->name, _MAX_PATH-1 );

            /* add it to the heap-based list */
            newptr = malloc( sizeof(list_of_names_t)+strlen(found) );
            newptr->nxt = NULL;
            strcpy( newptr->name, found );
            if (newptr)
                add_to_linked_list( newptr, &dir_list, &dir_list_tail );
            else
              {
                printf( "ERROR: heap full, malloc returned NULL, some subdirs skipped.\n" );
                rc = 2;
                break;
              }

            if (verbosity >= dash_v_c)
                printf("Subdir: '%s'\n", found );

            tmp = tmp->nxt;
          }/*while*/
      }

    return rc;
  } /* wildcard_cmpr_n_copies_both_ways */



int main( int argc, char * argv[] )
  {
   int option_ch, rc = 0, tmp_rc, len, len_dir;
   filepath_t file1, file2;

    /* First, process the '-' options.  Note that options can be combined,
       so "-qq" is the same as "-q -q", or "-bv" is the same as "-b -v"
    */
    while ((argc >= 2) && (('-' == argv[1][0]) || ('/' == argv[1][0])))
        /* Note: if we make a Unix/Linux version, we'll want to drop the '/' test */
      {
        if ('\0' == argv[1][1])
          { /* '-' alone ends options, in case first file name begins with '-' */
            /* delete the "-" from argv[] */
            argv[1] = argv[0];
            argv++;
            argc--;
            break;  /* break out of the 'while' loop */
          }

        for (option_ch=1; ('\0' != argv[1][option_ch]); option_ch++)
          {
            switch (argv[1][option_ch])
             {
              case 'b':  /* 1 for '-b' option, 2 for '-bb' option */
                bothways++;
                break;

              case 't':  /* '-t' option */
                testmode = true_c;
                break;

              case 'm':  /* '-m' option */
                makedirs = true_c;
                break;

              case 'i': /* '-i' option */
                dosubdirs = true_c;
                break;

              case 'q':
                if (verbosity)
                    verbosity--;  /* dash_q_c the first time ('-q'), dash_qq_c the 2nd time ('-qq') */
                break;

              case 'v':
                verbosity++;  /* dash_v_c the first time, dash_vv_c the 2nd time */
                break;

              case 'h':
              case '?':
                give_help();
                return 0;

              default:
                show_banner();
                printf( "ERROR: unrecognized option: %s\n", argv[1] );
                give_help();
                return 3;
             }/*switch*/
          }/*for*/

        /* delete the option from argv[] */
        argv[1] = argv[0];
        argv++;
        argc--;
      }/*while*/

    strcpy( option_str, "-" );
    if (bothways)
        strcat( option_str, "b" );
    if (bothways >= 2)
        strcat( option_str, "b" );
    if (makedirs)
        strcat( option_str, "m" );
    if (verbosity <= dash_qq_c)
        strcat( option_str, "qq" );
    else if (verbosity == dash_q_c)
        strcat( option_str, "q" );
    else if (verbosity == dash_v_c)
        strcat( option_str, "v" );
    else if (verbosity >= dash_vv_c)
        strcat( option_str, "vv" );
    if (option_str[1])
        strcat( option_str, " " );
    else
        option_str[0] = '\0';  /* no options */

/* Don't include the -i and -t options because we're gonna display a line
   for each subdirectory and we want them to be proper tlibcopy commands.

    if (dosubdirs)
        strncat( option_str, "i" );
    if (testmode)
        strncat( option_str, "t" );
*/

    if (argc != 3)  /* there should be exactly 2 command-line arguments left (plus the program name) */
      {
        show_banner();
        if (argc > 3)
          {
            printf( "ERROR: too many parameters.\n" );
          }
        give_help();
        return 3;
      }

    show_banner();


    my_strncpy( file2, argv[2], _MAX_PATH-1 );
    len = massage_target_dir( file2 );
    if (!len)
      { /* after we removed the dross, there was no file2 parameter left */
        show_banner();
        give_help();
        return 3;
      }

    /* If file2 doesn't end in a backslash (or slash or colon), check whether
       it is a directory; if so, add a trailing backslash.  The trailing
       backslash will tell cmpr_n_copy() to treat it as a directory.
    */
    if (is_directory_sans_trailing_backslash(file2))
        my_strncat( file2, "\\", _MAX_PATH-1 );

    /* if source was just a directory (with or without a trailing backslash),
       append a "*" wildcard spec to it */
    my_strncpy( file1, argv[1], _MAX_PATH-1 );
    massage_a_path( file1 );
    if (! is_wild_card_spec(file1))
      {
        if (ends_in_slash(file1))
            my_strncat( file1, "*", _MAX_PATH-1 );
        else if (is_directory_sans_trailing_backslash(file2))
            my_strncat( file1, "\\*", _MAX_PATH-1 );
      }
    else
      { /* change "*.*" to just "*" */
        len = strlen( file1 );
        if ((len >= 4) && !strcmp("\\*.*",file1+len-4))
            file1[len-2] = '\0';
      }

    if (verbosity >= dash_v_c)
      {
        /* suppressed unless -v specified */
        if (bothways)
            printf( "file1='%s', file2='%s'\n", file1, file2 );
        else
            printf( "FromFile='%s', ToFile='%s'\n", file1, file2 );
      }

    if (is_wild_card_spec(file2))
      {
        printf( "ERROR: wildcards are not permitted in file2 (destination), except for a plain \"*\".\n" );
        return 3;
      }

    len_dir = 1+LastSlashOrColonC( file1 );
    my_strncpy( top_file1_dir, file1, len_dir );
    strcpy( wcspec, file1+len_dir );
    len_dir = 1+LastSlashOrColonC( file2 );
    my_strncpy( top_file2_dir, file2, len_dir );
    strcpy( target_file_sans_dir, file2+len_dir );  /* usually 0-length */
    this_subdir[0] = '\0';
/*
    printf( "dbg:\n"
            "  file1                = '%s'\n"
            "  file2                = '%s'\n"
            "  top_file1_dir   = '%s'\n"
            "  top_file2_dir   = '%s'\n"
            "  wcspec               = '%s'\n"
            "  target_file_sans_dir = '%s'\n",
            file1, file2, top_file1_dir, top_file2_dir, wcspec, target_file_sans_dir );
*/

    if (is_wild_card_spec(file1) && target_file_sans_dir[0])
      {
        printf( "ERROR: if file1 is a wildcard spec or directory, file2 (destination) must be a directory.\n" );
        return 3;
      }

    if ((!is_wild_card_spec(file1)) && !dosubdirs)
      {
        /* no '*' or '?' in file1, and -i not specified, so just do one file */
        rc = cmpr_n_copy( file1, file2 );
        num_files_processed++;
        if (verbosity >= dash_v_c)  /* suppressed by default when not using wildcards */
          {
            if (0 == num_files_copied)
                printf( "1 file examined, 0 files" );
            else
                printf( "1 file examined, 1 file" );
            if (testmode)
                printf( " would be" );
            printf( " copied.\n" );
          }
      }
    else
      { /* expand wild-cards, and call cmpr_n_copy for each one */

        if ((bothways <= 1) && !dosubdirs)
            /* searches and compares/copies immediately; searches only in
               top_file1_dir, not in file2 and not in any subdirs: */
            rc = wildcard_cmpr_n_copies( file1, file2 );
        else /* ((bothways >= 2) || dosubdirs) */
          {
            /* Searches entire directory, building lists; then does the
               compares/copies.  Can search both file1 and file2 directories,
               and subdirectories. */
            this_subdir[0] = '\0';
            for (;;)
              {
                tmp_rc = wildcard_cmpr_n_copies_both_ways(
                           top_file1_dir, top_file2_dir, this_subdir, wcspec, target_file_sans_dir );
                if (tmp_rc > rc)
                    rc = tmp_rc;
                if (!dir_list)
                    break;  /* if dosubdires=false, we always break here */
                strcpy( this_subdir, dir_list->name );
                my_strncat( this_subdir, "\\", _MAX_PATH-1 );
                /* this_subdir always ends in '\' except when it is 0-length */
                dir_list = dir_list->nxt;  /* we could free() it, but I'd rather not fragment the heap */
              }
          }

        if (0 == num_files_processed)
          {
            if (verbosity >= dash_q_c)  /* -qq can suppress this msg */
              {
                strcpy( file1, top_file1_dir );
                my_strncpy( file1, wcspec, _MAX_PATH-1 );
                printf("ERROR: no files found matching '%s'\n", file1 );
              }
            if (!rc)
                rc = 1;  /* no files found is an error */
          }
        else
          {
            if (verbosity >= dash_default_c)  /* can be suppressed with -q */
              {
                if (num_files_processed > 1)
                    printf("%lu files examined, ", num_files_processed );
                else
                    printf( "1 file examined, " );
                /* note that this msg is enabled by default when using wildcards,
                   but requires -v to enable otherwise
                */
              }
            if (verbosity >= dash_q_c)
              {
                if (num_files_copied != 1)
                    printf( "%lu files", num_files_copied );
                else
                    printf( "1 file" );
                if (testmode)
                    printf( " would be" );
                printf( " copied.\n" );
              }
          }

      }/* end of code to expand wild-cards */

    if (verbosity >= dash_vv_c)
        printf( "errorlevel %d\n", rc );
    return rc;
  } /* main */
